(function (global, factory) {
	typeof exports === 'object' && typeof module !== 'undefined' ? factory(exports, require('@angular/core'), require('@angular/common'), require('@angular/http'), require('rxjs/add/operator/map'), require('rxjs/add/operator/toPromise')) :
	typeof define === 'function' && define.amd ? define(['exports', '@angular/core', '@angular/common', '@angular/http', 'rxjs/add/operator/map', 'rxjs/add/operator/toPromise'], factory) :
	(factory((global['couchdb-connector'] = {}),global.ng.core,global.ng.common,global.ng.http));
}(this, (function (exports,core,common,http) { 'use strict';

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes} checked by tsc
 */
var CouchdbDocComponent = /** @class */ (function () {
    function CouchdbDocComponent() {
    }
    CouchdbDocComponent.decorators = [
        { type: core.Component, args: [{
                    selector: 'couchdb-doc',
                    template: "<h1>{{class}}#{{_id}}</h1>"
                },] },
    ];
    /** @nocollapse */
    CouchdbDocComponent.ctorParameters = function () { return []; };
    return CouchdbDocComponent;
}());
var CouchdbListEntryComponent = /** @class */ (function () {
    function CouchdbListEntryComponent() {
    }
    CouchdbListEntryComponent.decorators = [
        { type: core.Component, args: [{
                    selector: 'couchdb-list-entry',
                    template: "<h1>{{doc.class}}#{{id}}</h1>"
                },] },
    ];
    /** @nocollapse */
    CouchdbListEntryComponent.ctorParameters = function () { return []; };
    return CouchdbListEntryComponent;
}());
var CouchdbViewEntryComponent = /** @class */ (function () {
    function CouchdbViewEntryComponent() {
    }
    CouchdbViewEntryComponent.decorators = [
        { type: core.Component, args: [{
                    selector: 'couchdb-view-entry',
                    template: "<h1>{{value.class}}#{{value._id}}</h1>"
                },] },
    ];
    /** @nocollapse */
    CouchdbViewEntryComponent.ctorParameters = function () { return []; };
    return CouchdbViewEntryComponent;
}());
var JSON_HEADERS = new http.Headers({ 'Content-Type': 'application/json' });
var CouchdbService = /** @class */ (function () {
    function CouchdbService(http$$1, dbName, viewName) {
        this.http = http$$1;
        this.dbName = dbName;
        this.viewName = viewName;
    }
    /** @returns all stored objects of class T */
    /**
     * @return {?} all stored objects of class T
     */
    CouchdbService.prototype.getAll = /**
     * @return {?} all stored objects of class T
     */
    function () {
        return this.http
            .get("/" + this.dbName + "/_all_docs?include_docs=true")
            .toPromise()
            .then(function (res) { return ((/** @type {?} */ (res.json().rows)).map(function (r) { return r.doc; })); })
            .catch(this.handleError);
    };
    /** @returns  all stored objects of class T matching keys */
    /**
     * @param {...?} keys
     * @return {?} all stored objects of class T matching keys
     */
    CouchdbService.prototype.getAllFor = /**
     * @param {...?} keys
     * @return {?} all stored objects of class T matching keys
     */
    function () {
        var keys = [];
        for (var _i = 0; _i < arguments.length; _i++) {
            keys[_i] = arguments[_i];
        }
        return this.http.get(this.getViewUrl(keys)).toPromise()
            .then(function (res) { return ((/** @type {?} */ (res.json().rows))
            .map(function (r) { return r.value; })); })
            .catch(this.handleError);
    };
    /**
     * Handles Exception during requests to couchdb.
     * Override this method for your own handler.
     */
    /**
     * Handles Exception during requests to couchdb.
     * Override this method for your own handler.
     * @param {?} error
     * @return {?}
     */
    CouchdbService.prototype.handleError = /**
     * Handles Exception during requests to couchdb.
     * Override this method for your own handler.
     * @param {?} error
     * @return {?}
     */
    function (error) {
        console.error('An error occurred', error);
        console.error('Error!\nMessage: ' + error.message);
        return Promise.reject(error.message || error);
    };
    /**
     * @param {?} id
     * @return {?}
     */
    CouchdbService.prototype.get = /**
     * @param {?} id
     * @return {?}
     */
    function (id) {
        return this.http
            .get("/" + this.dbName + "/" + id)
            .toPromise()
            .then(function (res) { return (res.json()); })
            .catch(this.handleError);
    };
    /**
     * @param {?} doc
     * @return {?}
     */
    CouchdbService.prototype.update = /**
     * @param {?} doc
     * @return {?}
     */
    function (doc) {
        return this.http
            .put("/" + this.dbName + "/" + doc._id, JSON.stringify(doc, function (key, value) { return (key === 'transient' ? undefined : value); }), { headers: JSON_HEADERS })
            .toPromise()
            .then(function (res) {
            var /** @type {?} */ r = res.json();
            doc._id = r.id;
            doc._rev = r.rev;
            return doc;
        })
            .catch(this.handleError);
    };
    /**
     * @param {?} doc
     * @return {?}
     */
    CouchdbService.prototype.create = /**
     * @param {?} doc
     * @return {?}
     */
    function (doc) {
        doc.class = doc.constructor.name;
        return this.http
            .post("/" + this.dbName, JSON.stringify(doc), { headers: JSON_HEADERS })
            .toPromise()
            .then(function (res) {
            var /** @type {?} */ r = res.json();
            doc._id = r.id;
            doc._rev = r.rev;
            return doc;
        })
            .catch(this.handleError);
    };
    /**
     * @param {?} id
     * @param {?} rev
     * @return {?}
     */
    CouchdbService.prototype.delete = /**
     * @param {?} id
     * @param {?} rev
     * @return {?}
     */
    function (id, rev) {
        return this.http
            .delete("/" + this.dbName + "/" + id + "?rev=" + rev, { headers: JSON_HEADERS })
            .toPromise()
            .then(function () { return null; })
            .catch(this.handleError);
    };
    /**
     * @param {?} field
     * @param {?} term
     * @return {?}
     */
    CouchdbService.prototype.search = /**
     * @param {?} field
     * @param {?} term
     * @return {?}
     */
    function (field, term) {
        return this.http
            .get("/" + this.dbName + "/_all_docs?include_docs=true")
            .map(function (res) {
            return (/** @type {?} */ (res.json().rows))
                .map(function (r) { return (r.doc); })
                .filter(function (t) { return t[field].indexOf(term) !== -1; });
        });
    };
    /**
     * @param {?} keys
     * @return {?}
     */
    CouchdbService.prototype.getViewUrl = /**
     * @param {?} keys
     * @return {?}
     */
    function (keys) {
        console.log('RestParameter: ' + JSON.stringify(keys) + keys.length);
        var /** @type {?} */ url = "/" + this.dbName + "/_design/couchapp/_view/" + this.viewName;
        if (keys.length === 1 && keys[0].trim()) {
            url += "?key=\"" + keys[0] + "\"";
        }
        else if (keys.length > 1) {
            url += "?key=\"" + JSON.stringify(keys) + "\"";
        }
        console.log(url);
        return url;
    };
    return CouchdbService;
}());

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes} checked by tsc
 */
var CouchdbModule = /** @class */ (function () {
    function CouchdbModule() {
    }
    /**
     * @return {?}
     */
    CouchdbModule.forRoot = /**
     * @return {?}
     */
    function () {
        return {
            ngModule: CouchdbModule,
            providers: [CouchdbService]
        };
    };
    CouchdbModule.decorators = [
        { type: core.NgModule, args: [{
                    imports: [
                        common.CommonModule, http.HttpModule
                    ],
                    declarations: [
                        CouchdbDocComponent,
                        CouchdbListEntryComponent,
                        CouchdbViewEntryComponent,
                    ],
                    exports: [
                        CouchdbDocComponent,
                        CouchdbListEntryComponent,
                        CouchdbViewEntryComponent,
                    ]
                },] },
    ];
    /** @nocollapse */
    CouchdbModule.ctorParameters = function () { return []; };
    return CouchdbModule;
}());

exports.CouchdbModule = CouchdbModule;
exports.CouchdbDocComponent = CouchdbDocComponent;
exports.CouchdbListEntryComponent = CouchdbListEntryComponent;
exports.CouchdbViewEntryComponent = CouchdbViewEntryComponent;
exports.CouchdbService = CouchdbService;

Object.defineProperty(exports, '__esModule', { value: true });

})));
