import { Http } from '@angular/http';
import { Observable } from 'rxjs/Observable';
import 'rxjs/add/operator/map';
import 'rxjs/add/operator/toPromise';
export declare class CouchdbDocComponent {
    _id: string;
    _rev: string;
    class: string;
}
export declare class CouchdbListEntryComponent {
    id: string;
    key: string;
    doc: CouchdbDocComponent;
}
export declare class CouchdbViewEntryComponent {
    value: CouchdbDocComponent;
}
export declare class CouchdbService<T extends CouchdbDocComponent> {
    protected http: Http;
    protected dbName: string;
    protected viewName: string;
    constructor(http: Http, dbName: string, viewName: string);
    /** @returns all stored objects of class T */
    getAll(): Promise<T[]>;
    /** @returns  all stored objects of class T matching keys */
    getAllFor(...keys: string[]): Promise<T[]>;
    /**
     * Handles Exception during requests to couchdb.
     * Override this method for your own handler.
     */
    protected handleError(error: any): Promise<any>;
    get(id: string): Promise<T>;
    update(doc: T): Promise<T>;
    create(doc: T): Promise<T>;
    delete(id: string, rev: string): Promise<void>;
    search(field: string, term: string): Observable<T[]>;
    getViewUrl(keys: string[]): string;
}
